// 
// File:          decaf_ports_ParameterPort_Impl.hh
// Symbol:        decaf.ports.ParameterPort-v0.6.3
// Symbol Type:   class
// Babel Version: 0.8.8
// Description:   Server-side implementation for decaf.ports.ParameterPort
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.8.8
// 

#ifndef included_decaf_ports_ParameterPort_Impl_hh
#define included_decaf_ports_ParameterPort_Impl_hh

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif
#ifndef included_decaf_ports_ParameterPort_IOR_h
#include "decaf_ports_ParameterPort_IOR.h"
#endif
// 
// Includes for all method dependencies.
// 
#ifndef included_SIDL_BaseInterface_hh
#include "SIDL_BaseInterface.hh"
#endif
#ifndef included_SIDL_ClassInfo_hh
#include "SIDL_ClassInfo.hh"
#endif
#ifndef included_decaf_ports_ParameterPort_hh
#include "decaf_ports_ParameterPort.hh"
#endif
#ifndef included_gov_cca_CCAException_hh
#include "gov_cca_CCAException.hh"
#endif
#ifndef included_gov_cca_Services_hh
#include "gov_cca_Services.hh"
#endif
#ifndef included_gov_cca_TypeMap_hh
#include "gov_cca_TypeMap.hh"
#endif
#ifndef included_gov_cca_ports_ParameterGetListener_hh
#include "gov_cca_ports_ParameterGetListener.hh"
#endif
#ifndef included_gov_cca_ports_ParameterSetListener_hh
#include "gov_cca_ports_ParameterSetListener.hh"
#endif


// DO-NOT-DELETE splicer.begin(decaf.ports.ParameterPort._includes)
#include <list>
#include <map>
#include <set>
#ifndef included_decaf_TypeMap_hh
#include "decaf_TypeMap.hh"
#endif
// DO-NOT-DELETE splicer.end(decaf.ports.ParameterPort._includes)

namespace decaf { 
  namespace ports { 

    /**
     * Symbol "decaf.ports.ParameterPort" (version 0.6.3)
     */
    class ParameterPort_impl
    // DO-NOT-DELETE splicer.begin(decaf.ports.ParameterPort._inherits)
    // Put additional inheritance here...
    // DO-NOT-DELETE splicer.end(decaf.ports.ParameterPort._inherits)
    {

    private:
      // Pointer back to IOR.
      // Use this to dispatch back through IOR vtable.
      ParameterPort self;

      // DO-NOT-DELETE splicer.begin(decaf.ports.ParameterPort._implementation)
      typedef std::map< std::string, std::string> dict_t;
      std::list<std::string> d_entries;

      std::string d_title;
      decaf::TypeMap d_data;
      decaf::TypeMap d_default;
      decaf::TypeMap d_upper;
      decaf::TypeMap d_lower;
      dict_t d_help;
      dict_t d_prompt; 
      std::map< std::string, std::set< std::string > > d_stringChoice;
      std::map< std::string, std::set< int32_t > > d_intChoice;
      std::map< std::string, std::set< int64_t > > d_longChoice;
      std::map< std::string, std::set< float > > d_floatChoice;
      std::map< std::string, std::set< double > > d_doubleChoice;
      std::map< std::string, std::set< SIDL::fcomplex, SIDL::fcomplex_less > > d_fcomplexChoice;
      std::map< std::string, std::set< SIDL::dcomplex, SIDL::dcomplex_less > > d_dcomplexChoice;

      // DO-NOT-DELETE splicer.end(decaf.ports.ParameterPort._implementation)

    private:
      // private default constructor (required)
      ParameterPort_impl() {} 

    public:
      // SIDL constructor (required)
      // Note: alternate Skel constructor doesn't call addref()
      // (fixes bug #275)
      ParameterPort_impl( struct decaf_ports_ParameterPort__object * s ) : 
        self(s,true) { _ctor(); }

      // user defined construction
      void _ctor();

      // virtual destructor (required)
      virtual ~ParameterPort_impl() { _dtor(); }

      // user defined destruction
      void _dtor();

    public:


      /**
       * Initialize the portData for use in a ParameterPort
       *  with name portName.
       *  More than one such port can be defined.
       *  The given string portName will be cached in the TypeMap
       *  as the result of this function and must not be changed
       *  by the component henceforth.
       *  
       *  @param portData the user-supplied TypeMap associated with the port;
       *       It is somehow shared between the ParameterPortFactory
       *       and the component. The ParameterPortFactory will
       *       not read or change preexisting values in portData except those
       *       requested via the addRequest functions and those
       *       keys starting with the reserved prefix "gcpPPF.".
       *  @param portName The name of the ParameterPort to appear in
       *       the component. It must not conflict with other port
       *       names in the same component. The port name "CONFIG"
       *       is recommended if only one ParameterPort is being defined.
       *  
       * 
       */
      void
      initParameterData (
        /*inout*/ ::gov::cca::TypeMap& portData,
        /*in*/ const ::std::string& portName
      )
      throw () 
      ;


      /**
       * Define the window title for the parameter UI dialog.
       */
      void
      setBatchTitle (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& title
      )
      throw () 
      ;


      /**
       * Define the next tab/group title to use. All
       * addRequest subsequent calls will add to this group.
       * Multiple dialog tabs/groups can be defined in this way.
       */
      void
      setGroupName (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& newGroupName
      )
      throw () 
      ;

      /**
       * user defined non-static method.
       */
      void
      setGroupName (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& newGroupName,
        /*in*/ const ::std::string& groupTitle
      )
      throw () 
      ;


      /**
       * Define a boolean parameter and its default state.
       * The configured value is always available by
       * portData->getBool(name, ...);
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestBoolean (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ bool bdefault
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a int parameter and its default state.
       * The configured value is always available by
       * portData->getInt(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestInt (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ int32_t idefault,
        /*in*/ int32_t low,
        /*in*/ int32_t high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a long parameter and its default state.
       * The configured value is always available by
       * portData->getLong(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestLong (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ int64_t ldefault,
        /*in*/ int64_t low,
        /*in*/ int64_t high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a float parameter and its default state.
       * The configured value is always available by
       * portData->getFloat(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestFloat (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ float fdefault,
        /*in*/ float low,
        /*in*/ float high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a double parameter and its default state.
       * The configured value is always available by
       * portData->getDouble(name, ...) and it will be
       * in the range [low, high]. The initially given bounds
       * can be replaced with a choice list later.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestDouble (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ double ddefault,
        /*in*/ double low,
        /*in*/ double high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a string parameter and its default state.
       * The configured value is always available by
       * portData->getString(name, ...).
       * If no addRequestStringChoice calls are made, the
       * user input may be any string. If addRequestStringChoice
       * is used, the value will be one among the choices.
       * If addRequestStringChoice is used, deflt must
       * be among the choices defined.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestString (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ const ::std::string& help,
        /*in*/ const ::std::string& prompt,
        /*in*/ const ::std::string& sdefault
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Define a new choice for a string parameter.
       *  If no calls to this function are made for a given
       *  name, then any form of string will be acceptable input.
       * @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      addRequestStringChoice (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& key,
        /*in*/ const ::std::string& choice
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * As addRequestStringChoice, but in bulk. 
       */
      void
      addStringChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& key,
        /*in*/ ::SIDL::array< ::std::string> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addIntChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array<int32_t> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addLongChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array<int64_t> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addFloatChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array<float> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addDoubleChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array<double> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addFcomplexChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array< ::SIDL::fcomplex> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Replace the bounds on the named parameter by a list. 
       */
      void
      addDcomplexChoices (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ const ::std::string& name,
        /*in*/ ::SIDL::array< ::SIDL::dcomplex> choices
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Clear all previously added requests, titles, groups. After
       *  this call, it is as if the ParameterPort has
       *  seen initParameterData but otherwise never configured.
       *  The values of
       *  previously defined parameters (but not bounds, etc)
       *  remain in the TypeMap.
       *  Typically, this is used only by someone implementing
       *  the updateParameterPort function from
       *  interface ParameterGetListener.
       */
      void
      clearRequests (
        /*in*/ ::gov::cca::TypeMap portData
      )
      throw () 
      ;


      /**
       * Register listener (the component) that wishes to have
       * a chance to change the contents of its ParameterPort
       * just before the parameters TypeMap is read.
       * @param powner a pointer to the listener that will be
       * forgotten when it is no longer needed. 
       */
      void
      registerUpdater (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ ::gov::cca::ports::ParameterGetListener powner
      )
      throw () 
      ;


      /**
       * Register listener (the component) if it wishes to be
       * informed when an parameter is changed via writeConfigurationMap.
       * Listeners are called after values are set.
       */
      void
      registerUpdatedListener (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ ::gov::cca::ports::ParameterSetListener powner
      )
      throw () 
      ;


      /**
       * Signal that the ParameterPort is fully defined and should
       * now pop out on the component.
       * The component is free to hold the portData map internally
       * without adding it until some desired time.
       * The Services passed here
       * must be the component's own Services handle.
       * The ParameterPortFactory takes care of addProvidesPort.
       */
      void
      addParameterPort (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ ::gov::cca::Services svc
      )
      throw () 
      ;


      /**
       * Cause a previously defined parameter port to go away.
       * This function should be called at component shutdown
       * (setService(0)) time for any parameter ports that have
       * been added but not yet removed.
       * The ParameterPortFactory takes care of removeProvidesPort.
       * This does not change the parameter values in the
       * TypeMap.
       */
      void
      removeParameterPort (
        /*in*/ ::gov::cca::TypeMap portData,
        /*in*/ ::gov::cca::Services svc
      )
      throw () 
      ;


      /**
       * Return a TypeMap of runtime configuration parameters. 
       *  @throws gov.cca.CCAException if mapName is unknown.
       */
      ::gov::cca::TypeMap
      readConfigurationMap() throw ( 
        ::gov::cca::CCAException
      );

      /**
       * Copy the parameter values given in map into the
       * internal map, for those parameters which
       * are already defined by the internal map.
       * The outsider does not get to cause arbitrary
       * keys to be copied into the internal map.
       * @throws gov.cca.CCAException if TypeMap operations fail.
       */
      void
      writeConfigurationMap (
        /*in*/ ::gov::cca::TypeMap map
      )
      throw () 
      ;


      /**
       * Fetch the list of keys in the TypeMap that are
       *   for public configuration purposes. Other values found in
       *   the TypeMap must not be changed.
       */
      ::SIDL::array< ::std::string>
      readConfigurationKeys() throw () 
      ;

      /**
       * Fetch configuration title. 
       *  @return Description of data set.
       */
      ::std::string
      readTitle() throw () 
      ;

      /**
       * Fetch the names of groups. Each page in a tabbed dialog
       *  goes with a group, for example.
       */
      ::SIDL::array< ::std::string>
      readGroupNames() throw () 
      ;

      /**
       * Fetch UI-appropriate name for group.
       *  Group name and group title may be the same.
       *  @throws gov.cca.CCAException if groupName is unknown.
       */
      ::std::string
      readGroupTitle (
        /*in*/ const ::std::string& groupName
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch data item keys associated with groupName.
       *  Array order will be the same as the order in which
       *  the additions were made in the ParameterPortFactory interface.
       *  @throws gov.cca.CCAException if groupName is unknown.
       */
      ::SIDL::array< ::std::string>
      readGroupKeys (
        /*in*/ const ::std::string& groupName
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the help string for key.
       *  @throws gov.cca.CCAException if key is unknown.
       */
      ::std::string
      readHelp (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the prompt string for key.
       *  @throws gov.cca.CCAException if key is unknown.
       */
      ::std::string
      readPrompt (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * By default, bounds are defined except for complex numbers
       *  booleans, and strings. On array types, bounds apply
       *  element-wise. i.e.  low <= arr[i] <= high for all i.
       *  @return true if simple bounds are defined for a key.
       *  @throws gov.cca.CCAException if key is unknown.
       */
      bool
      hasBounds (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * By default, lists of choices are not defined for scalars or arrays.
       *  Choices are applied element-wise for array types.
       *  I.e. (arr[i] IN choice-set) == true  for all i.
       *  @return true if choice list is defined for a key.
       *  @throws gov.cca.CCAException if key is unknown.
       */
      bool
      hasChoices (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for boolean-typed key. 
       *  @thr2ows gov.cca.CCAException if key is unknown or mistyped.
       */
      bool
      readDefaultBoolean (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for string-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::std::string
      readDefaultString (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for integer-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      int32_t
      readDefaultInt (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for long-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      int64_t
      readDefaultLong (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for float-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      float
      readDefaultFloat (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for double-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      double
      readDefaultDouble (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for fcomplex-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::std::complex<float>
      readDefaultFcomplex (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for dcomplex-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::std::complex<double>
      readDefaultDcomplex (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for string-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::std::string>
      readDefaultStringArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for boolean-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<bool>
      readDefaultBooleanArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for integer-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<int32_t>
      readDefaultIntArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for long-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<int64_t>
      readDefaultLongArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for float-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<float>
      readDefaultFloatArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for double-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<double>
      readDefaultDoubleArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for fcomplex-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::SIDL::fcomplex>
      readDefaultFcomplexArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for dcomplex-array-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::SIDL::dcomplex>
      readDefaultDcomplexArray (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the bounds for integer-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      readBoundsInt (
        /*in*/ const ::std::string& key,
        /*out*/ int32_t& low,
        /*out*/ int32_t& high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for long-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      readBoundsLong (
        /*in*/ const ::std::string& key,
        /*out*/ int64_t& low,
        /*out*/ int64_t& high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for float-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      readBoundsFloat (
        /*in*/ const ::std::string& key,
        /*out*/ float& low,
        /*out*/ float& high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for double-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      void
      readBoundsDouble (
        /*in*/ const ::std::string& key,
        /*out*/ double& low,
        /*out*/ double& high
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the choices for string(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::std::string>
      readChoicesString (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the choices for integer(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<int32_t>
      readChoicesInt (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the choices for long(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<int64_t>
      readChoicesLong (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the choices for float(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<float>
      readChoicesFloat (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for double(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array<double>
      readChoicesDouble (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for fcomplex(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::SIDL::fcomplex>
      readChoicesFcomplex (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Fetch the default for dcomplex(-array)-typed key. 
       *  @throws gov.cca.CCAException if key is unknown or mistyped.
       */
      ::SIDL::array< ::SIDL::dcomplex>
      readChoicesDcomplex (
        /*in*/ const ::std::string& key
      )
      throw ( 
        ::gov::cca::CCAException
      );

    };  // end class ParameterPort_impl

  } // end namespace ports
} // end namespace decaf

// DO-NOT-DELETE splicer.begin(decaf.ports.ParameterPort._misc)
// Put miscellaneous things here...
// DO-NOT-DELETE splicer.end(decaf.ports.ParameterPort._misc)

#endif
